<?php
/**
 * 'Charlies content' generates XHTML depending on the element
 * PDF / Musics / Videos / Zip / and any you want
 */

function Charlies_content($picture)
{
  global $page, $template, $charlie, $conf;

  $link = '<link rel="stylesheet" type="text/css" '
        . 'href="'.get_root_url().'plugins/charlies_content/charlies.css">';
  $template->assign_block_vars(
      'head_element',
       array(
         'CONTENT' => $link,
    )
  );

  // Which player is needed?
  $player = '';
  $extension = strtolower(get_extension($picture['file']));
  foreach ($charlie as $tpl => $ext)
  {
    if (in_array($extension, $ext))
    {
      $player = strtolower($tpl);
    }
  }
  // Active Charlie's player template
  $template->set_filenames(
    array('default_content'
    => PHPWG_PLUGINS_PATH."charlies_content/charlie_$player.tpl")
    );

  $path = $picture['element_path'];
  $url = $picture['element_url'];
  if ( substr($url,0,4)!='http' and substr($url,0,1)!='/' )
  {
    set_make_full_url();
    $url = get_element_url( $picture );;
    unset_make_full_url();
  }

  // Get info via getid3

  if ( !url_is_remote($path) )
  {
    require_once(PHPWG_PLUGINS_PATH.'charlies_content/getid3/getid3/getid3.php');
    $prev_lvl = error_reporting(E_ERROR | E_WARNING | E_PARSE);
    $getID3 = new getID3;
    $fileinfo = $getID3->analyze($path);
    $prev_lvl = error_reporting($prev_lvl);
  }
  else
  {
    $fileinfo['asf']['video_media'][2]['format_data']['image_width'] =
      $conf['video_default_width'];
    $fileinfo['asf']['video_media'][2]['format_data']['image_height'] =
      $conf['video_default_height'];
  }
  if (isset($fileinfo['meta']['onMetaData']['width'])) {
    $fileinfo['video']['resolution_x'] = 
      $fileinfo['meta']['onMetaData']['width']; 
    $fileinfo['video']['resolution_y'] = 
      $fileinfo['meta']['onMetaData']['height']; 
  }
  $fileinfo['video']['resolution_x'] =
    (int) @$fileinfo['video']['resolution_x'];
  if ( $fileinfo['video']['resolution_x'] < 2 )
  {
    $fileinfo['video']['resolution_x'] = $conf['video_default_width'];
    $fileinfo['video']['resolution_y'] = $conf['video_default_height'];
  }
  if ( $fileinfo['video']['resolution_y'] < 0 )
  {
    $fileinfo['video']['resolution_x'] = $conf['video_default_width'];
    $fileinfo['video']['resolution_y'] =
      (int) (18*$conf['video_default_width']/32);
  }
  $bg = get_root_url().'plugins/charlies_content/background.png';

  //var_dump($fileinfo);

  // Assign as much we can to offer different fields to display
  $template->assign_vars( array(
      'SRC_IMG'    => $url,
      'SRC_IMG_ENCODED' => urlencode($url),
      'BG_SRC_ENCODED'  => urlencode($bg),
      'ALT_IMG'    => $picture['file'],
      'H_MUSIC'    => '44',
      'W_MUSIC'    => '450',
      'WW_VIDEO'   => (int) @$fileinfo['asf']['video_media'][2]['format_data']['image_width'],
      'WH_VIDEO'   => 25 + (int) @$fileinfo['asf']['video_media'][2]['format_data']['image_height'],
      // 25 +  ... is for reader height
      'C_VIDEO'    => 55,
      'FW_VIDEO'   => (int)  @$fileinfo['video']['resolution_x'],
      'FH_VIDEO'   => 20 + (int)  @$fileinfo['video']['resolution_y'],
      'FILENAME'   =>  basename($path),
      'FILESIZE'   => $picture['filesize'],
      'WIDTH'      => @$fileinfo['meta']['onMetaData']['width'],
      'HEIGHT'      => @$fileinfo['meta']['onMetaData']['height'],
      'FRAMERATE' => @$fileinfo['meta']['onMetaData']['framerate'],
      'STEREO' => (@$fileinfo['meta']['onMetaData']['stereo']) ?
                  'stereo' : 'mono', // l10n TODO
      'BITRATE' => @$fileinfo['bitrate'],
      'PLAYTIME' => @$fileinfo['playtime_string'],
      )
    );

  $ret = $template->parse('default_content', true);
//  echo $ret;
  return $ret;
}
?>